(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: complete.mli,v 1.11.2.1 2008/02/13 16:00:27 bonichon Exp $ *)

(** {3 Completion of algebraic properties.} *)

val genr_function_definitions :
  (string * 'a list * Parsetree.relations * Location.t) list ->
  Genr_base.function_definition list;;
(** Some relations on a generator imply relations on other
  generators, that the user cannot or does not need to
  provide. The function [genr_function_definitions] returns the list of
  function definitions corresponding to a list of generator definitions,
  after having added all the required properties.

  [genr_function_definitions] preserves the following properties:
  - a relation does not appear twice,
  - the relations are sorted wrt the predicate [Relation.compare_relation]. *)


val get_user_rel_order : unit -> bool
;;
val set_user_rel_order : unit -> unit
;;
