(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: genr_sharing.mli,v 1.18 2008/02/11 23:05:59 weis Exp $ *)

(** Generation of functions to get maximal sharing for the values of a given
    type. *)

val mk_sharing_function_ident : Code.uident -> Code.lident
;;

val generator_underscore : Code.uident * Code.exp list -> Code.exp
;;

val print_sharing_mli_preamble : Buffer.t -> unit
;;

val print_sharing_ml_preamble : Buffer.t -> unit
;;

val print_sharing : Buffer.t ->
  (string * Parsetree.type_declaration) list -> unit
;;

val add_info_arg_to_type_declaration :
  Parsetree.type_declaration -> Parsetree.type_declaration
;;

val print_type_private_structure_items : Buffer.t ->
  (string * Parsetree.type_declaration) list -> unit
(** Prints the structure items defined in the private type definition. *)
;;
