(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* variables *)

type var = int;;

open Useful;;

module VarSet = IntSet;;
module VarMap = IntMap;;

let var_of_string, clear_vars =
  let stmap = ref StrMap.empty
  and n = ref 0 in
    (fun s ->
       (try StrMap.find s !stmap
	with Not_found ->
	  incr n;
	  stmap := StrMap.add s !n !stmap;
	  !n)),
    (fun () ->
       stmap := StrMap.empty;
       n := 0)
;;

let string_of_var = function
  | 0 -> "x"
  | 1 -> "y"
  | 2 -> "z"
  | 3 -> "w"
  | n when n > 0 -> "x" ^ string_of_int (n-3)
  | n -> "y" ^ string_of_int (-n)
;;
