(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Laura Lowenthal, projet Protheo, INRIA Lorraine           *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: typed_vars.mli,v 1.5 2008/01/23 15:32:25 lowenthl Exp $ *)

(** {Deducing mapping typed variables to values Code.exp.} *)

open Var
open Term
open Parsetree

type typed_var = var * core_type
;;

exception Unknown_type
;;

val typed_vars : term -> typed_var list
;;

val typed_vars_eqn : Equation.eqn -> typed_var list
;;

val vars_by_type : typed_var list -> (core_type * var list) list
;;
